/*
  THIS PROGRAM DISCLOSES MATERIAL PROTECTABLE UNDER COPYRIGHT
  LAWS OF THE UNITED STATES.  FOR LICENSING INFORMATION CONTACT:

  Christian Bischof or Lucas Roh, Mathematics and Computer Science Division,
  Argonne National Laboratory, 9700 S. Cass Avenue, Argonne IL 60439,
  {bischof,roh}@mcs.anl.gov.
*/

#ifdef __cplusplus
extern "C" {
#endif

void ad_AD_SetNumberOfIndep(int);

void ad_grad_axpy_n(int, void*, ...);

#ifdef __cplusplus
}
#endif

#define ad_grad_axpy_copy(ggz,ggx) DERIV_grad(*(ggz))[0] = DERIV_grad(*(ggx))[0];

#define ad_grad_axpy_0(ggz) DERIV_grad(*(ggz))[0] = 0.0;

#define ad_grad_axpy_1(_ggz, _c1, _gg1) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0]; }

#define ad_grad_axpy_2(_ggz, _c1, _gg1, _c2, _gg2) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0]; }

#define ad_grad_axpy_3(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0]; }

#define ad_grad_axpy_4(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0]; }

#define ad_grad_axpy_5(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0]; }

#define ad_grad_axpy_6(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0]; }

#define ad_grad_axpy_7(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0]; }

#define ad_grad_axpy_8(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0]; }

#define ad_grad_axpy_9(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0]; }

#define ad_grad_axpy_10(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0]; }

#define ad_grad_axpy_11(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0]; }

#define ad_grad_axpy_12(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0]; }

#define ad_grad_axpy_13(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0]; }

#define ad_grad_axpy_14(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0]; }

#define ad_grad_axpy_15(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0]; }

#define ad_grad_axpy_16(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0]; }

#define ad_grad_axpy_17(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0]; }

#define ad_grad_axpy_18(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0]; }

#define ad_grad_axpy_19(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0]; }

#define ad_grad_axpy_20(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0]; }

#define ad_grad_axpy_21(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0]; }

#define ad_grad_axpy_22(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0]; }

#define ad_grad_axpy_23(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0]; }

#define ad_grad_axpy_24(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0]; }

#define ad_grad_axpy_25(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0]; }

#define ad_grad_axpy_26(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0]; }

#define ad_grad_axpy_27(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0]; }

#define ad_grad_axpy_28(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27, _c28, _gg28) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0] +(_c28)*DERIV_grad(*(_gg28))[0]; }

#define ad_grad_axpy_29(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27, _c28, _gg28, _c29, _gg29) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0] +(_c28)*DERIV_grad(*(_gg28))[0] +(_c29)*DERIV_grad(*(_gg29))[0]; }

#define ad_grad_axpy_30(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27, _c28, _gg28, _c29, _gg29, _c30, _gg30) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0] +(_c28)*DERIV_grad(*(_gg28))[0] +(_c29)*DERIV_grad(*(_gg29))[0] +(_c30)*DERIV_grad(*(_gg30))[0]; }

#define ad_grad_axpy_copy(ggz,ggx) DERIV_grad(*(ggz))[0] = DERIV_grad(*(ggx))[0];

#define ad_grad_axpy_0(ggz) DERIV_grad(*(ggz))[0] = 0.0;

#define ad_grad_axpy_1(_ggz, _c1, _gg1) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0]; }

#define ad_grad_axpy_2(_ggz, _c1, _gg1, _c2, _gg2) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0]; }

#define ad_grad_axpy_3(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0]; }

#define ad_grad_axpy_4(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0]; }

#define ad_grad_axpy_5(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0]; }

#define ad_grad_axpy_6(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0]; }

#define ad_grad_axpy_7(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0]; }

#define ad_grad_axpy_8(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0]; }

#define ad_grad_axpy_9(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0]; }

#define ad_grad_axpy_10(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0]; }

#define ad_grad_axpy_11(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0]; }

#define ad_grad_axpy_12(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0]; }

#define ad_grad_axpy_13(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0]; }

#define ad_grad_axpy_14(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0]; }

#define ad_grad_axpy_15(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0]; }

#define ad_grad_axpy_16(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0]; }

#define ad_grad_axpy_17(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0]; }

#define ad_grad_axpy_18(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0]; }

#define ad_grad_axpy_19(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0]; }

#define ad_grad_axpy_20(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0]; }

#define ad_grad_axpy_21(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0]; }

#define ad_grad_axpy_22(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0]; }

#define ad_grad_axpy_23(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0]; }

#define ad_grad_axpy_24(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0]; }

#define ad_grad_axpy_25(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0]; }

#define ad_grad_axpy_26(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0]; }

#define ad_grad_axpy_27(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0]; }

#define ad_grad_axpy_28(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27, _c28, _gg28) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0] +(_c28)*DERIV_grad(*(_gg28))[0]; }

#define ad_grad_axpy_29(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27, _c28, _gg28, _c29, _gg29) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0] +(_c28)*DERIV_grad(*(_gg28))[0] +(_c29)*DERIV_grad(*(_gg29))[0]; }

#define ad_grad_axpy_30(_ggz, _c1, _gg1, _c2, _gg2, _c3, _gg3, _c4, _gg4, _c5, _gg5, _c6, _gg6, _c7, _gg7, _c8, _gg8, _c9, _gg9, _c10, _gg10, _c11, _gg11, _c12, _gg12, _c13, _gg13, _c14, _gg14, _c15, _gg15, _c16, _gg16, _c17, _gg17, _c18, _gg18, _c19, _gg19, _c20, _gg20, _c21, _gg21, _c22, _gg22, _c23, _gg23, _c24, _gg24, _c25, _gg25, _c26, _gg26, _c27, _gg27, _c28, _gg28, _c29, _gg29, _c30, _gg30) { DERIV_grad(*(_ggz))[0] =  +(_c1)*DERIV_grad(*(_gg1))[0] +(_c2)*DERIV_grad(*(_gg2))[0] +(_c3)*DERIV_grad(*(_gg3))[0] +(_c4)*DERIV_grad(*(_gg4))[0] +(_c5)*DERIV_grad(*(_gg5))[0] +(_c6)*DERIV_grad(*(_gg6))[0] +(_c7)*DERIV_grad(*(_gg7))[0] +(_c8)*DERIV_grad(*(_gg8))[0] +(_c9)*DERIV_grad(*(_gg9))[0] +(_c10)*DERIV_grad(*(_gg10))[0] +(_c11)*DERIV_grad(*(_gg11))[0] +(_c12)*DERIV_grad(*(_gg12))[0] +(_c13)*DERIV_grad(*(_gg13))[0] +(_c14)*DERIV_grad(*(_gg14))[0] +(_c15)*DERIV_grad(*(_gg15))[0] +(_c16)*DERIV_grad(*(_gg16))[0] +(_c17)*DERIV_grad(*(_gg17))[0] +(_c18)*DERIV_grad(*(_gg18))[0] +(_c19)*DERIV_grad(*(_gg19))[0] +(_c20)*DERIV_grad(*(_gg20))[0] +(_c21)*DERIV_grad(*(_gg21))[0] +(_c22)*DERIV_grad(*(_gg22))[0] +(_c23)*DERIV_grad(*(_gg23))[0] +(_c24)*DERIV_grad(*(_gg24))[0] +(_c25)*DERIV_grad(*(_gg25))[0] +(_c26)*DERIV_grad(*(_gg26))[0] +(_c27)*DERIV_grad(*(_gg27))[0] +(_c28)*DERIV_grad(*(_gg28))[0] +(_c29)*DERIV_grad(*(_gg29))[0] +(_c30)*DERIV_grad(*(_gg30))[0]; }

