package Template::Find;

use Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(find_template_file);
@EXPORT_OK = qw();

use PurseConstants qw(@TEMPLATE_DIRS $TEMPLATE_EXTENSION);
use PurseErrors;
use English;


sub find_template_file { 
    my($template_file) = @_;
    my($found_template) = 0;
    my($dir);

    $template_file =~ tr/A-Z/a-z/;
    $template_file .= $TEMPLATE_EXTENSION; 

    foreach $dir (@TEMPLATE_DIRS)
    {
        if ( -f "$dir/$template_file" )
        {
            $template_file = "$dir/$template_file";
            $found_template = 1;
            last; # stop scanning
        }
    }
    
    # Print @template_dirs one per line
    local($")="\n";
    
    &die_input_problem("Unable to find $template_file in search path:\n@TEMPLATE_DIRS")
        if ( ! $found_template );

    return ($template_file);
}


1;
